Package com.io7m.jregions.core.parameterized.areas

# Class PAreaBD.Builder<S>

java.lang.Object
com.io7m.jregions.core.parameterized.areas.PAreaBD.Builder<S>

Enclosing class:
  PAreaBD<S>

public static final class PAreaBD.Builder<S> extends Object
Builds instances of type `PAreaBD`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PAreaBD<S>`
  `build()`
  Builds a new `PAreaBD`.
  `final PAreaBD.Builder<S>`
  `from(PAreaBDType<S> instance)`
  Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.areas.PAreaBDType` instance.
  `final PAreaBD.Builder<S>`
  `from(AreaValuesBDType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.areas.AreaValuesBDType` instance.
  `final PAreaBD.Builder<S>`
  `setMaximumX(BigDecimal maximumX)`
  Initializes the value for the `maximumX` attribute.
  `final PAreaBD.Builder<S>`
  `setMaximumY(BigDecimal maximumY)`
  Initializes the value for the `maximumY` attribute.
  `final PAreaBD.Builder<S>`
  `setMinimumX(BigDecimal minimumX)`
  Initializes the value for the `minimumX` attribute.
  `final PAreaBD.Builder<S>`
  `setMinimumY(BigDecimal minimumY)`
  Initializes the value for the `minimumY` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PAreaBD.Builder<S> from(AreaValuesBDType instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.areas.AreaValuesBDType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PAreaBD.Builder<S> from(PAreaBDType<S> instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.areas.PAreaBDType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinimumX

    public final PAreaBD.Builder<S> setMinimumX(BigDecimal minimumX)
    Initializes the value for the `minimumX` attribute.
    Parameters:
      `minimumX` - The value for minimumX
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaximumX

    public final PAreaBD.Builder<S> setMaximumX(BigDecimal maximumX)
    Initializes the value for the `maximumX` attribute.
    Parameters:
      `maximumX` - The value for maximumX
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinimumY

    public final PAreaBD.Builder<S> setMinimumY(BigDecimal minimumY)
    Initializes the value for the `minimumY` attribute.
    Parameters:
      `minimumY` - The value for minimumY
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaximumY

    public final PAreaBD.Builder<S> setMaximumY(BigDecimal maximumY)
    Initializes the value for the `maximumY` attribute.
    Parameters:
      `maximumY` - The value for maximumY
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PAreaBD<S> build()
    Builds a new `PAreaBD`.
    Returns:
      An immutable instance of PAreaBD
    Throws:
      `IllegalStateException` - if any required attributes are missing